# Copyright (C) 2009 Joerg Faschingbauer

# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.

# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA

from libconfix.core.machinery.setup import CompositeSetup
from libconfix.plugins.automake.setup import AutomakeSetup
from libconfix.plugins.automake.pkg_config.setup import PkgConfigSetup
from libconfix.plugins.automake.c.library_dependencies import LibraryDependenciesFinderSetup

class Automake(CompositeSetup):
    def __init__(self, use_libtool, library_dependencies):
        CompositeSetup.__init__(self,
                                [AutomakeSetup(use_libtool=use_libtool),
                                 PkgConfigSetup()
                                 ])
        if library_dependencies:
            self.add_setup(LibraryDependenciesFinderSetup(use_libtool=use_libtool))
            pass
        pass
    pass
